// ********* STOL U KUTU *********

#declare stol =
union {
      cylinder { <1.6,0,0> <1.6,6,0>,0.25 }
      cylinder { <1.6,0,0> < 1.6,6,0>,0.25 rotate y*90 }
      cylinder { <1.6,0,0> <1.6,6,0>,0.25 rotate y*180 }
      cylinder { <1.6,0,0> <1.6,6,0>,0.25 rotate y*270 }

      torus { 2.0,0.125 translate y*3 }
      cylinder { <0,3,0> <0,3.125,0>,2 } // DRVO

      torus { 2.5,0.25 translate y*5.75 }
      cylinder { <0,5.75,0> <0,6,0>,2.5 } // DRVO

      #declare rota01 = 0
      #while ( rota01 < 360 )
      torus { 0.5,0.25
            translate <2.5,5.75,0>
            rotate y*rota01
      }
      sphere { <1.6,3,0>,0.25
      rotate y*rota01
      }

      #declare rota01 = rota01 + 10
      #end
      texture { wood01 }
      hollow
}


// ********* MAGICNA KUGLA *********

#declare magsph01 =
union {
   // ********* TIJELO - DRZAC KUGLE *********
   difference {
      union {
         sphere { <0,0,0>,1 scale <1,1,0.2> translate y*1 }
         sphere { <0,0,0>,1 scale <0.2,1,1> translate y*1 }
         sphere { <0,0,0>,1 scale <1,1,0.2> translate y*1 rotate y*45 }
         sphere { <0,0,0>,1 scale <0.2,1,1> translate y*1 rotate <0,-135,0> }
      }
      sphere { <0,0,0>,1 scale <0.9,0.9,0.9> translate y*1.2 }
      cylinder { <0,1.4,0> <0,2,0>,2 }
   texture { pigment { color rgbf <0.8,0.8,0.825> } finish { Shiny ambient 0.3 diffuse 0.7 }}
   }
   cone { <0,0,0>,1 <0,0.5,0>,0.7
     texture { Silver1 }
   }
   sphere { <0,0,0>,1
     scale <0.9,0.9,0.9>
     translate y*1.2
     texture { pigment { color rgbf <0,0.8,1,0.5> } finish { ambient 1 diffuse 0.5 }}
   }
   // ********* MAGICNA KUGLA - SJAJ *********
   sphere { <0,0,0>,1
     texture { pigment { color rgbt <1,1,1,1> } }
     halo {
       spherical_mapping
       linear
       emitting
       color_map {
         [ 0   color rgbt <0,0.6,1,0.5> ]
         [ 0.2 color rgbt <0,0,0,2> ]
         [ 1   color rgbt <0,0,0,2> ]
       }
       turbulence 0.4
       scale 0.8
     }
     scale 1.1
     translate y*1.2
     hollow
  }
}

// ********** MAGICNI STAPIC **********

#declare stick01 =
union {
  cylinder { <2,0,0> <-2,0,0>,0.1 }
  union {
    sphere   { <2,0,0>,0.125 }
    sphere   { <-1.6,0,0>,0.125 }
    sphere   { <1.6,0,0>,0.125 }
    sphere   { <-2,0,0>,0.125 }
    cylinder { <2,0,0> <1.6,0,0>,0.125 }
    cylinder { <-2,0,0> <-1.6,0,0>,0.125 }
    texture  { Silver1 }
  }
  texture { pigment { color rgb <0.3,0.3,0.3> } finish { Shiny} }
  translate y*0.125
}

// ********** KNJIGA **********

#declare book01 =
union {
   #declare fpage = union {
    box { <-1.25,1,-1.5> <1.25,0.9,1.5> }
    cylinder { <-1.25,0.95,-1.5> <1.25,0.95,-1.5>,0.05 }
    cylinder { <-1.25,0.95,1.5> <1.25,0.95,1.5>,0.05 }
    cylinder { <1.25,0.95,1.5> <1.25,0.95,-1.5>,0.05 }
    sphere   { <1.25,0.95,1.5>,0.05 }
    sphere   { <1.25,0.95,-1.5>,0.05 }

  }
  difference {
    union {
       cylinder { <0,0,1.5> <0,0,-1.5>,0.5 }
       torus { 0.45, 0.05 rotate x*90 translate <0,0,-1.5> }
       torus { 0.45, 0.05 rotate x*90 translate <0,0,1.5> }
       scale <0.2,1,1>
       translate <-1.25,0.5,0>
    }
    cylinder { <0,0,1.6> <0,0,-1.6>,0.45 scale <0.2,1,1> translate <-1.25,0.5,0> }
    box { <-1.25,0,-1.6> <1.25,1,1.6> }
  }
  // ********** STRANICE **********
  difference {
    box { <-1.25,0.9,-1.5> <1.25,0.1,1.5> }
    cylinder { <0,0.5,1.6> <0,0.5,-1.6>,0.5 scale <0.2,1,1> translate x*1.25 }
    texture { Paper_Tex01 }
  }
  object { fpage }
  object { fpage translate y*(-0.9)}
  texture {
     material_map {
        gif "magic.gif"
        texture {
           Book_tex01 scale 0.5
        }
        texture { Gold_Texture }
     }
     rotate x*90
     scale <2.5,1,3>
     translate <-1.25,0,-1.5>
  }
}

// ********** STOLAC SA SVIM ELEMENTIMA **********

#declare  TABLEALL =
union {
 object {
    magsph01
    translate y*6
    translate <-1,0,1>
  }
  object { stol }
  object { stick01 translate y*6 rotate y*15 translate z*(-2) }
  object { book01 rotate y*25 translate <1.5,6,0> }
}

